public class TestInsertionSort {
  public static void main(String args[]) {
    int a[] = {8,4,6,2,1};

    System.out.println("Before sorting:");
    for (int i = 0; i < a.length; i++)
      System.out.print(a[i] + " ");
    System.out.println();

    // For each pass:
    for (int i = 1; i < a.length; i++) {
      // Keep next value to be inserted
      int value = a[i];
      // Shift all values in the sorted part
      // of the array greater than this
      // one position backwards in the array.
      int j;
      for (j = i;
           (j > 0 && value < a[j-1]);
           j--)
        a[j] = a[j-1];  // shift backwards!
      a[j] = value;     // insert value in correct position!
    }

    System.out.println("After sortng:");
    for (int i = 0; i < a.length; i++)
      System.out.print(a[i] + " ");
    System.out.println();
  }
}

