class TestBinarySearch {
  public static void main(String[] args) {
    int a[] = {11,19,24,30,32,48,50,55,72,99}; // values in ascending order.
    int key = 48;

    int low = 0, high = a.length - 1, middle = -1;
    boolean found = false, moreElements = true;
    while (moreElements && !found) {
      middle = (low + high) / 2;                  // middle of the array
      if (low > high) moreElements = false;       // key is not in array
      else if (a[middle] == key) found = true;    // key is in a[middle]
      else if (a[middle] < key) low = middle + 1; // if key in array, it must be in upper half
      else high = middle - 1;                 // if key in array, it must be in lower half
    }
    // !(moreElements && !found) <=> (!moreElements || found)
    assert (!moreElements || found) : "Error in binary search";
    if (found)
      System.out.println("Value " + key + " found in element with index " + middle);
    else
      System.out.println("Value " + key + " is not in array!");
  }
}